Description

Collapsed with collapse macro sections don't have an edit link. More than this, all following edit links don't work properly, because

service-side numeration take into account all sections, even collapsed, but client-side doesn't.

Related issues:

Related to Redmine - Defect #26974: Collapse macro conflicts with header sect... New

History

#1 - 2013-11-13 10:58 - Vadim Pushtaev

I can't reproduce the “more than this” part.

Considering the first part. Here is what we have in app/helpers/application_helper.rb (line 527):

macros = catch_macros(text)

#...

parse_sections(text, project, obj, attr, only_path, options)

 catch_macros is a mutator, all instances of {{ macro ... }} in text are placed with {{macro(N)}}, so there is no chance parse_sections can see <h1>...

inside. I don't know whether it was made on purpose or not, but I believe you can reject this issue.

#2 - 2014-02-02 09:00 - Asaf H

It happens to me as well (the part before the "more than this").

Is there a reason you suggested rejecting this issue?

#3 - 2014-02-02 09:56 - Vadim Pushtaev

It's not exactly a bug, it looks more like a feature.

#4 - 2014-02-02 13:39 - Asaf H

Maybe an unavoidable behavior, but a feature?

If there are sections inside a collapser, why shouldn't the user be able to edit them?

I think it's best if the formatter treats the collapse as a section. That way you can edit the entire collapse, or any section within it, same as you would

any section.

#5 - 2014-02-03 09:38 - Vadim Pushtaev

Yeah, it would be perfect and natural, but unfortunately macros are just not made this way.

#6 - 2017-10-12 16:59 - Toshi MARUYAMA

- Related to Defect #26974: Collapse macro conflicts with header section edit buttons added

#7 - 2023-06-13 14:42 - Marcin Szewczyk

- File expand-macros-before-parsing-sections.patch added

Hi, in the 5.0.3 version the problem is still present. I attach a one-line patch that I intend to test on production (5.0.3) someday soon. For now I've

tested it with version 4.2.3. app/helpers/application_helper.rb doesn't contain many changes between those versions so the patch should be still

relevant. Testing via wiki edition (headings inside collapse, headings with inline code, TOC), running rake test and ruby

test/helpers/application_helper_test.rb suggests it's OK. Although, I must admit that I may be missing something as I don't understand how the patch

from r8841 fixed some of the problems. My ruby skills are almost nonexistent so I'm probably missing some scope nuances.

#8 - 2023-06-21 04:26 - Go MAEDA
https://www.redmine.org/projects/redmine/repository/svn/revisions/8841


- File clipboard-202306211125-xdbw9.png added

- Status changed from New to Confirmed

I have confirmed the issue and the patch posted in #note-7 fixes the issue.

Wiki page content:

h1. Test-13723

{{collapse 

h2. foo 

 

The quick brown fox jumps over the lazy dog. 

}}

h2. bar

test test

 With the patch applied:

 clipboard-202306211125-xdbw9.png 

Files

expand-macros-before-parsing-sections.patch 747 Bytes 2023-06-13 Marcin Szewczyk

clipboard-202306211125-xdbw9.png 47.2 KB 2023-06-21 Go MAEDA
